<?php
/*
Plugin Name: Flexible Navigation
Description: Adds a flex accordion navigation to your blog.
Author: Jesse DeMarco
Version: 0.09
Plugin URI: http://dreamwagon.com/blog/?p=18
Author URI: http://dreamwagon.com/blog
*/

//Need to create class for admin functions.
if (!class_exists("FlexibleNav")) {
	//var $adminOptionsName = "FlexibleNavAdminOptions";
	//TODO
    class FlexibleNav {

	var $adminOptionsName = "FlexibleNavigationAdminOptions";
        function FlexibleNav() { //constructor
        }
		
		function getAdminOptions(){
			
			$flexnavAdminOptions = array('flexnav_style' => 'sunburst.swf',
										 'flexnav_height' => '420',
										 'flexnav_width' => '330',
										 'flexnav_posts' => 'True',
										 'flexnav_links' => 'True',
										 'flexnav_cats' => 'True',
										 'flexnav_posts_name' => 'Posts',
										 'flexnav_links_name' => 'Links',
										 'flexnav_cats_name' => 'Catagories'
										);
			$devOptions = get_option($this->adminOptionsName);
			
			if (!empty($devOptions)) {
                foreach ($devOptions as $key => $option)
                    $flexnavAdminOptions[$key] = $option;
            } 

			update_option($this->adminOptionsName, $flexnavAdminOptions);
            return $flexnavAdminOptions;

		}
		
        function init() {
            $this->getAdminOptions();
              }
		function printAdminPage() {
		
			$devOptions = $this->getAdminOptions();
			if (isset($_POST['update_flexnavSettings'])) {
			if (isset($_POST['FLXSTYLE'])) {
				$devOptions['flexnav_style'] = $_POST['FLXSTYLE'];
				}
			if (isset($_POST['FLXHEIGHT'])) {
				$devOptions['flexnav_height'] = $_POST['FLXHEIGHT'];
				}
			if (isset($_POST['FLXWIDTH'])) {
				$devOptions['flexnav_width'] = $_POST['FLXWIDTH'];
				}
			if (isset($_POST['FLXPOSTS'])) {
				$devOptions['flexnav_posts'] = $_POST['FLXPOSTS'];
				}
			if (isset($_POST['FLXLINKS'])) {
				$devOptions['flexnav_links'] = $_POST['FLXLINKS'];
				}
			if (isset($_POST['FLXCATS'])) {
				$devOptions['flexnav_cats'] = $_POST['FLXCATS'];
				}
			if (isset($_POST['FLXPOSTNAME'])) {
				$devOptions['flexnav_posts_name'] = $_POST['FLXPOSTNAME'];
				}
			if (isset($_POST['FLXLINKNAME'])) {
				$devOptions['flexnav_links_name'] = $_POST['FLXLINKNAME'];
				}
			if (isset($_POST['FLXCATNAME'])) {
				$devOptions['flexnav_cats_name'] = $_POST['FLXCATNAME'];
				}
			update_option($this->adminOptionsName, $devOptions);
			?>
			<div class="updated"><p><strong><?php _e("Settings Updated.", "FlexibleNavigation");?></strong></p></div>
			<?php }
			?>
			<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
			<div class="wrap">
			<h2> Flexible Navigation Configuration </h2>
			
			<table class="form-table">
				<tr valign="top">
                    <th scope="row"><label>Navigation Style</label></th>
                    <td><?php getFlexNavStyles();?></td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Embed Height</label></th>
                    <td><input type="text" name="FLXHEIGHT" value="<?php echo $devOptions['flexnav_height'] ?>" /></td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Embed Width</label></th>
                    <td><input type="text" name="FLXWIDTH" value="<?php echo $devOptions['flexnav_width'] ?>" /></td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Posts Name</label></th>
                    <td><input type="text" name="FLXPOSTNAME" value="<?php echo $devOptions['flexnav_posts_name'] ?>" />
					<br/>This is the text that will appear as the heading for the posts</td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Use Posts</label></th>
                    <td><select name="FLXPOSTS">
						<option>True</option>
						<option>False</option>
						</select>
					</td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Links Name</label></th>
                    <td><input type="text" name="FLXLINKNAME" value="<?php echo $devOptions['flexnav_links_name'] ?>" />
					<br/>This is the text that will appear as the heading for the links</td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Use Links</label></th>
                    <td><select name="FLXLINKS">
						<option>True</option>
						<option>False</option>
						</select></td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Catagories Name</label></th>
                    <td><input type="text" name="FLXCATNAME" value="<?php echo $devOptions['flexnav_cats_name'] ?>" />
					<br/>This is the text that will appear as the heading for the catagories</td>
                </tr>
				<tr valign="top">
                    <th scope="row"><label>Use Catagories</label></th>
                    <td><select name="FLXCATS" >
						<option>True</option>
						<option>False</option>
						</select></td>
                </tr>
				<tr>
				<th> More Info</th>
				<td> You must use at least two headings for this plugin to work. Modify flexible-navigation.php around line 225+
				if you would like to add some customization. Please leave feedback, and suggestions!
				<tr>
				<tr>
					<td><input type="submit" name="update_flexnavSettings" value="<?php _e('Update Settings', 'FlexibleNavigation') ?>" /></td>
				</tr>
			</table>
			</div>
			
			</form>
			<?php 	 
		}
    }
}// end FlexibleNav

    if (class_exists("FlexibleNav")) {
        $flexnav = new FlexibleNav();
    }
	  
	if (isset($flexnav)) {
    //Actions
	add_action('admin_menu', 'FlexibleNavigation_ap');
	add_action('activate_flexible-navigation/flexible-navigation.php',  array(&$flexnav, 'init'));
   
    //Filters
	}

    //Initialize the admin panel
    if (!function_exists("FlexibleNavigation_ap")) {
          function FlexibleNavigation_ap() {
              global $flexnav;
              if (!isset($flexnav)) {
                  return;
              }
              if (function_exists('add_options_page')) {
			  add_options_page('Flexible Navigation', 'Flexible Navigation', 9, basename(__FILE__), array(&$flexnav, 'printAdminPage'));
              }
          }   
    }


//One big function to add Navigation.
function AddFlexNav() {
 //****************************************************************************************************
 //Navigation variables.
 //These variables will eventually be set in some panel.
 //For now edit them here
 global $flexnav;
 $fxopt = $flexnav->getAdminOptions();
 
  //Style file to handle the header style. Look in the css-swf folder.
  //style and file must match (minus the .swf)
  $style=$fxopt["flexnav_style"];
  $l = strlen($style);
  $e = $l-4;
  $styleFile=$fxopt["flexnav_style"];
  $styleName=substr($style,0,$e);;
 
  //The two variables control the embed and object size
  $navHeight = $fxopt["flexnav_height"];;
  $navWidth = $fxopt["flexnav_width"];;
  
  //These control the actual application size. Should be a scaler of embed size. Better to leave these be. although if 
  // you are having trouble with sizing you may modify the scaling values directly.
  $appHeight = $navHeight-40;
  $appWidth  = $navWidth-10;
  
  $u_psts = $fxopt["flexnav_posts"];
  $u_lnks = $fxopt["flexnav_links"];
  $u_cats = $fxopt["flexnav_cats"];
  
  //Titles for use in the nav
  $postName = $fxopt["flexnav_posts_name"];
  $linkName = $fxopt["flexnav_links_name"];
  $catName = $fxopt["flexnav_cats_name"];
  
  //Main array of headings --DONT CHANGE
  $headings = array();
 //****************************************************************************************************
	global $wpdb;
	$pst = array();
	$lnk = array();
	$cat = array();
	
		//Note: The nav must have at least two headings or nothing will dispay.
		//Of course if you have less than two headings, why would you use this plugin :)
		//Need to standardize the nameing to nav_link and nav_title
		
		//Take some items from the database to display in the nav
		//Add the Links
		if ($u_psts == "True"){
		$ahh = $wpdb->get_results("SELECT link_url, link_name FROM $wpdb->links");
		foreach( $ahh as $b )
		{
		$lnk[] = array("nav_link" => $b->link_url, "nav_title" => $b->link_name );
		}
		$headings[] = array("items" => $lnk, "title" => $linkName);
		}
		
		//Add the Posts
		if ($u_lnks == "True"){
		$bah = $wpdb->get_results("SELECT guid, post_title FROM $wpdb->posts");
		foreach( $bah as $b )
		{
		$pst[] = array("nav_link" => $b->guid, "nav_title" => $b->post_title );
		}
		$headings[] = array("items" => $pst, "title" => $postName);
		}
		//Add the Catagories
		//Assumes your url uses ?cat= not pretty urls
		if ($u_cats == "True"){
		$cah = $wpdb->get_results("SELECT term_id, name FROM $wpdb->terms");
		foreach( $cah as $b )
		{
		$cat[] = array("nav_link" => '?cat='.$b->term_id, "nav_title" => $b->name );
		}
		$headings[] = array("items" => $cat, "title" => $catName);
		}
		//If there are some other links you can add them here as an array.
		//A manual entry to the navigation conists of an array of arrays in this format. 
		/* EXAMPLE 
		$some_other_links = array( array("nav_link" => "http://www.google.com", "nav_title" => "google"),
								   array("nav_link" => "http://www.yahoo.com", "nav_title" => "yahoo"),
								   array("nav_link" => "http://www.astalavista.com", "nav_title" => "astalavista") 
								  ); 
		$headings[] = array("items" => $some_other_links, "title" => "Search Engines");			
		*/

//*********NOTHING BELOW HERE!!!*************************************************************
  $doc  = new DOMDocument();
  $doc->formatOutput = true;
  
  $r = $doc->createElement( "a_nav" );
  $doc->appendChild( $r );
  
  foreach( $headings as $h )
  {
  $b = $doc->createElement( "heading" );
  $htitle = $doc->createAttribute( "title" );
  $ht = $doc->createAttribute( "height" );
  $wd = $doc->createAttribute( "width" );
  
	$htitle->appendChild($doc->createTextNode( $h["title"] ));
    $ht->appendChild($doc->createTextNode( $navHeight ));
    $wd->appendChild($doc->createTextNode( $navWidth ));
  
	$b->appendChild($htitle);
	$b->appendChild($ht);
	$b->appendChild($wd);
	foreach( $h["items"] as $p )
	{
	  $link = $doc->createElement( "link" );
	  $link->appendChild(
	  $doc->createTextNode( $p["nav_link"] )
	  );
	  $b->appendChild( $link );
	  
	  $linkname = $doc->createAttribute( "linkname" );
	  $linkname->appendChild(
	  $doc->createTextNode( $p["nav_title"] )
	  );
	  $link->appendChild($linkname);
	}
  $r->appendChild( $b );
  }

  $doc->save("wp-content/plugins/flexible-navigation/data/properties.xml");
?>
<object
codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" 
width="<?php echo $navWidth ?>" height="<?php echo $navHeight ?>" id="CTSA" align="middle">
<param name="allowScriptAccess" value="always" />
<param name="movie" value="<?php bloginfo('url');?>/wp-content/plugins/flexible-navigation/Navigation.swf" /><param name="quality" value="high" />
<param name="scale" value="noborder" /><param name="wmode" value="transparent" />
<param name="bgcolor" value="#ffffff" />
<param name="flashvars" value="httpServiceURL=<?php bloginfo('url');?>/wp-content/plugins/flexible-navigation/data/properties.xml&appHeight=<?php echo $appHeight ?>&appWidth=<?php echo $appWidth ?>&appStyleFile=<?php bloginfo('url');?>/wp-content/plugins/flexible-navigation/css-swf/<?php echo $styleFile ?>&appStyle=<?php echo $styleName ?>" />
<embed src="<?php bloginfo('url');?>/wp-content/plugins/flexible-navigation/Navigation.swf" quality="high" scale="noborder" wmode="transparent" bgcolor="#ffffff" width="<?php echo $navWidth ?>" height="<?php echo $navHeight ?>" 
name="CTSA" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" 
flashvars="httpServiceURL=<?php bloginfo('url');?>/wp-content/plugins/flexible-navigation/data/properties.xml&appHeight=<?php echo $appHeight ?>&appWidth=<?php echo $appWidth ?>&appStyleFile=<?php bloginfo('url');?>/wp-content/plugins/flexible-navigation/css-swf/<?php echo $styleFile ?>&appStyle=<?php echo $styleName ?>"/>
</object>
<?php
}
?>
<?php 

  
  		//Gets all the styles in the css-swf directory
	function getFlexNavStyles() {
		$files = array();
		if ($handle = opendir('../wp-content/plugins/flexible-navigation/css-swf')) {
		while (false !== ($file = readdir($handle))) {
			$l = strlen($file);
			$e = $l-4;
			if ($file != "." && $file != ".." && substr($file, $e) == ".swf") {
				$files[] = $file;
			}
		}
		closedir($handle);
		}

		echo '<SELECT name=FLXSTYLE>';
		foreach ($files as $f)
		{
		echo '<OPTION value='.$f.'> '.$f.'';
		}
		echo '</select>';
	}
?>